﻿using System.Collections.Generic;
using System.Linq;

namespace AutocompleteBox
{
	public class CollectionAutocompleteProvider : IAutocompleteProvider
	{
		private IList<string> items;

		public event SuggestionsReceivedEventHandler SuggestionsReceived;

		public CollectionAutocompleteProvider()
		{
			#region Collection with words, beginning with A
			this.items = new List<string>()
			{
				"aba",
				"abacinate",
				"abactor",
				"abaculus",
				"abaft",
				"abampere",
				"abapical",
				"abarticular",
				"abasement",
				"abasia",
				"abask",
				"abatis",
				"abatjour",
				"abattoir",
				"abature",
				"abb",
				"abba",
				"abbatial",
				"abbozzo",
				"abditive",
				"abdominous",
				"abducent",
				"abeam",
				"abear",
				"abecedarian",
				"abecedism",
				"abele",
				"aberdevine",
				"aberuncators",
				"abessive",
				"abiectic",
				"abigail",
				"abigeus",
				"abiogenesis",
				"abiotrophy",
				"abirritate",
				"abiturient",
				"abject",
				"ablactation",
				"ablative",
				"ablator",
				"ablaut",
				"ablegate",
				"ablepsia",
				"ablow",
				"abluent",
				"ablutomania",
				"abnegate",
				"abodement",
				"aboideau",
				"abolla",
				"abomasum",
				"aboral",
				"abord",
				"aborning",
				"aborticide",
				"abortuary",
				"aboulia",
				"aboulomania",
				"aboutsledge",
				"abra",
				"abradant",
				"abraid",
				"abraxas",
				"abreuvoir",
				"abroach",
				"abrosia",
				"abscind",
				"abscissa",
				"abscission",
				"absconce",
				"abseil",
				"absentaneous",
				"absinthial",
				"absinthism",
				"absit",
				"absolutism",
				"absolutive",
				"absolutory",
				"absonant",
				"absorbefacient",
				"absorptiometer",
				"absquatulate",
				"absterge",
				"absurdism",
				"abterminal",
				"abthane",
				"abulia",
				"abuna",
				"abusion",
				"abutment",
				"abvolt",
				"aby",
				"abyssopelagic",
				"academicism",
				"acanaceous",
				"acantha",
				"acanthous",
				"acapnia",
				"acapnotic",
				"acariasis",
				"acaricide",
				"acarine",
				"acarology",
				"acarophobia",
				"acarpous",
				"acatalectic",
				"acatalepsy",
				"acatamathesia",
				"acates",
				"acatour",
				"acaudate",
				"acaulescent",
				"accelerometer",
				"accend",
				"accensor",
				"accentor",
				"acceptilation",
				"accessit",
				"acciaccatura",
				"accidence",
				"accidentalism",
				"accidie",
				"accinge",
				"accipiter",
				"accipitral",
				"accipitrine",
				"accismus",
				"accite",
				"acclinate",
				"acclivity",
				"accloy",
				"accolade",
				"accolent",
				"accosted",
				"accoucheur",
				"accoucheuse",
				"accourage",
				"accourt",
				"accoy",
				"accrementition",
				"accretion",
				"accubation",
				"accubitum",
				"accusative",
				"acedia",
				"aceldama",
				"aceology",
				"acequia",
				"acerate",
				"acerbate",
				"acerous",
				"acersecomic",
				"acervate",
				"acervuline",
				"acescence",
				"acetabulum",
				"acetarious",
				"acetimeter",
				"achaenocarp",
				"acharné",
				"achene",
				"achloropsia",
				"achor",
				"achromatopsia",
				"achroous",
				"acicular",
				"acidaemia",
				"acidimeter",
				"acidulous",
				"acierate",
				"acinaceous",
				"acinaciform",
				"aciniform",
				"acinus",
				"acipenser",
				"aclinic",
				"acock",
				"acoemeti",
				"acology",
				"acolous",
				"acolouthic",
				"acopic",
				"acoria",
				"acosmism",
				"acouasm",
				"acquest",
				"acracy",
				"acratia",
				"acre-breadth",
				"acritochromacy",
				"acroamatic",
				"acrocephalous",
				"acrography",
				"acrolith",
				"acrologic",
				"acromegaly",
				"acronical",
				"acronym",
				"acronyx",
				"acropathy",
				"acrophobia",
				"acrophonic",
				"acropodium",
				"acroscopic",
				"acroteleutic",
				"acroterion",
				"acrotism",
				"actinism",
				"actinograph",
				"actinometer",
				"actinotherapy",
				"actuate",
				"aculeate",
				"aculeiform",
				"acultomancy",
				"acuminate",
				"acutiator",
				"acutorsion",
				"acyanopsia",
				"acyesis",
				"acyrology",
				"adactylous",
				"adamantine",
				"adamitism",
				"adaxial",
				"addax",
				"additament",
				"addititious",
				"addle",
				"addorsed",
				"adduce",
				"adeciduate",
				"adeem",
				"adelaster",
				"adelphogamy",
				"ademption",
				"adenalgia",
				"adenia",
				"adeniform",
				"adenography",
				"adenoid",
				"adenology",
				"adenotomy",
				"adespota",
				"adessive",
				"adevism",
				"adharma",
				"adhibit",
				"adhocracy",
				"adiabatic",
				"adiaphoresis",
				"adiaphorism",
				"adiaphoron",
				"adiapneustia",
				"adiathermancy",
				"adipescent",
				"adipic",
				"adipocere",
				"adipsia",
				"adit",
				"adjudge",
				"adjutage",
				"adjutor",
				"adjuvant",
				"admanuensis",
				"admaxillary",
				"admeasurement",
				"adminicle",
				"adnascent",
				"adnominal",
				"adnomination",
				"adnoun",
				"adonise",
				"adoptionism",
				"adoral",
				"adosculation",
				"adoxography",
				"adoxy",
				"adpress",
				"adrogation",
				"adscititious",
				"adscript",
				"adsorb",
				"adumbrate",
				"adunc",
				"aduncate",
				"adust",
				"advection",
				"advehent",
				"advenient",
				"adventitious",
				"adventive",
				"adversaria",
				"adversative",
				"advert",
				"advertorial",
				"advesperate",
				"advocaat",
				"advowson",
				"adynamia",
				"adytum",
				"aedile",
				"aedoeology",
				"aegilops",
				"aegis",
				"aegrotat",
				"aeneous",
				"aeolian",
				"aeolipyle",
				"aeolistic",
				"aeolotropy",
				"aeonian",
				"aerenchyma",
				"aeriform",
				"aerious",
				"aerobe",
				"aerobiology",
				"aerodonetics",
				"aerogenesis",
				"aerography",
				"aerolite",
				"aerolith",
				"aerolithology",
				"aerology",
				"aeromancy",
				"aerometer",
				"aerophane",
				"aerophilately",
				"aerophobia",
				"aerophore",
				"aeropleustic",
				"aerostat",
				"aerostatics",
				"aeruginous",
				"aerugo",
				"aesc",
				"aesopian",
				"aesthesia",
				"aesthesiogenic",
				"aestheticism",
				"aestival",
				"aethrioscope",
				"aeviternal",
				"aeviternity",
				"afebrile",
				"affabulation",
				"affeer",
				"afferent",
				"affiance",
				"affine",
				"afflated",
				"afflatus",
				"afforce",
				"afforest",
				"affranchise",
				"affray",
				"affrayer",
				"affreightment",
				"affreux",
				"affricate",
				"affronté",
				"affusion",
				"afore",
				"afterclap",
				"afterdeck",
				"aftergame",
				"afterguard",
				"afterings",
				"afterpiece",
				"aftershaft",
				"afterwil",
				"agacerie",
				"agalactia",
				"agalloch",
				"agamist",
				"agamogenesis",
				"agape",
				"agapeistic",
				"agapet",
				"agapetae",
				"agapism",
				"agastopia",
				"agatewear",
				"agathism",
				"agathodaimon",
				"agelast",
				"agennesic",
				"agenocratia",
				"agentive",
				"ageotropic",
				"agersia",
				"ageusia",
				"agger",
				"aggerose",
				"aggiornamento",
				"aggrade",
				"aggrandize",
				"aggrate",
				"aggry",
				"agio",
				"agiotage",
				"agist",
				"agistment",
				"aglet",
				"agma",
				"agminate",
				"agnail",
				"agname",
				"agnation",
				"agnize",
				"agnomen",
				"agnosic",
				"agnosticism",
				"agnosy",
				"agoge",
				"agogic",
				"agomphosis",
				"agone",
				"agonic",
				"agonism",
				"agonistes",
				"agonistic",
				"agonistics",
				"agoraphobia",
				"agowilt",
				"agraffe",
				"agrapha",
				"agraphia",
				"agravic",
				"agrestic",
				"agriology",
				"agrize",
				"agrizoiatry",
				"agrobiology",
				"agrology",
				"agromania",
				"agronomics",
				"agrostography",
				"agrostology",
				"agrypnia",
				"agrypnotic",
				"aguardiente",
				"agyiophobia",
				"agynary",
				"ahimsa",
				"ahull",
				"ai",
				"aichmophobia",
				"aiger",
				"aigrette",
				"aiguille",
				"aileron",
				"ailette",
				"ailuromancy",
				"ailurophilia",
				"ailurophobia",
				"aioli",
				"airscrew",
				"aischrolatry",
				"aisling",
				"ait",
				"aitchbone",
				"aiué",
				"akeratophorous",
				"akinesia",
				"ala",
				"alabamine",
				"alack",
				"alalia",
				"alameda",
				"alamort",
				"alannah",
				"alar",
				"alastrim",
				"alate",
				"alation",
				"alaudine",
				"alb",
				"albarello",
				"albata",
				"albedo",
				"albescent",
				"albicant",
				"albificative",
				"albion",
				"albocracy",
				"albolith",
				"albugineous",
				"alcahest",
				"alcatote",
				"alcine",
				"alcoholometer",
				"alcovinometer",
				"aleatoric",
				"aleberry",
				"alecost",
				"alectormancy",
				"alectryomachy",
				"alectryomancy",
				"alee",
				"alegar",
				"alembicated",
				"alepine",
				"alethiology",
				"aleuromancy",
				"alexia",
				"alexipharmic",
				"alfet",
				"alforge",
				"algedonics",
				"algefacient",
				"algetic",
				"algicide",
				"algid",
				"alginuresis",
				"algolagnia",
				"algology",
				"algophobia",
				"algor",
				"algraphy",
				"alible",
				"alidade",
				"aliform",
				"aligerous",
				"aliped",
				"aliphatic",
				"aliquant",
				"aliquot",
				"aliter",
				"alk",
				"alkalimeter",
				"alkanet",
				"allantiasis",
				"allantoid",
				"allative",
				"allemain",
				"allemande",
				"alliaceous",
				"allicient",
				"allision",
				"allocatur",
				"allochthonous",
				"allodic",
				"allogamy",
				"allogeneous",
				"allography",
				"allolalia",
				"allonge",
				"allonym",
				"allotheism",
				"allotriophagy",
				"allotropy",
				"alluvion",
				"almacantar",
				"almagest",
				"almandine",
				"almoner",
				"almuce",
				"alnager",
				"alogism",
				"alomancy",
				"alopecia",
				"alopecoid",
				"alow",
				"alpaca",
				"alpenglow",
				"alpenstocker",
				"alpestrine",
				"alphenic",
				"alphitomancy",
				"alphonsin",
				"alt",
				"altarage",
				"alterity",
				"alternatim",
				"altiloquence",
				"altisonant",
				"altitonant",
				"altricial",
				"aludel",
				"aluminiferous",
				"alveary",
				"alveolate",
				"alveromancy",
				"alviducous",
				"alvine",
				"ama",
				"amadelphous",
				"amain",
				"amanous",
				"amanuensis",
				"amaranth",
				"amaranthine",
				"amasesis",
				"amasthenic",
				"amathophobia",
				"amaxophobia",
				"ambages",
				"ambeer",
				"ambisinistrous",
				"ambit",
				"ambo",
				"ambry",
				"ambsace",
				"ambulatory",
				"ambulomancy",
				"ambulophobia",
				"ambustion",
				"amende",
				"ament",
				"amerce",
				"ametropia",
				"amice",
				"amicicide",
				"amidships",
				"ammeter",
				"ammophilous",
				"amnicolist",
				"amniomancy",
				"amorce",
				"amoret",
				"amoretto",
				"ampelidious",
				"ampelography",
				"ampere",
				"amphibiolith",
				"amphibolic",
				"amphibology",
				"amphigean",
				"amphigory",
				"amphimixis",
				"amphipneust",
				"amphisbaena",
				"amphiscian",
				"amplexus",
				"ampliative",
				"amplivagant",
				"ampulla",
				"amrita",
				"amygdaloid",
				"amyloid",
				"amyous",
				"an",
				"ana",
				"anabasis",
				"anabiosis",
				"anacampserote",
				"anacamptic",
				"anacardic",
				"anacathartic",
				"anachoric",
				"anaclastic",
				"anaclitic",
				"anacoluthon",
				"anacrisis",
				"anacrusis",
				"anacusic",
				"anadem",
				"anadiplosis",
				"anadromous",
				"anaerectic",
				"anaesthesiology",
				"anagalactic",
				"anaglyph",
				"anaglyptics",
				"anaglyptography",
				"anagnorisis",
				"anagogy",
				"anagraphy",
				"analects",
				"analemma",
				"analgia",
				"anamnesis",
				"anamorphic",
				"anandrious",
				"ananym",
				"anapeiratic",
				"anapest",
				"anaphalantiasis",
				"anaphia",
				"anaphora",
				"anapnea",
				"anastasic",
				"anastrophe",
				"anatine",
				"anatocism",
				"anatreptic",
				"anaudia",
				"anbury",
				"anchorite",
				"ancillary",
				"ancipitous",
				"ancistroid",
				"ancon",
				"anconoid",
				"ancoral",
				"ancress",
				"andiron",
				"andragogy",
				"androcracy",
				"androlepsia",
				"andromania",
				"androphagy",
				"aneabil",
				"anele",
				"anemocracy",
				"anemograph",
				"anemography",
				"anemology",
				"anemometer",
				"anemophilous",
				"anencephalic",
				"anent",
				"anergia",
				"anesis",
				"aneuria",
				"anfractuous",
				"angary",
				"angelocracy",
				"angelolatry",
				"angelology",
				"angelus",
				"angiogenesis",
				"angiology",
				"anglomania",
				"anglophilia",
				"anglophobia",
				"angora",
				"angstrom",
				"anguiform",
				"anguilliform",
				"anguine",
				"anguine",
				"anhedonia",
				"anhelation",
				"anhidrosis",
				"aniconic",
				"anicular",
				"anile",
				"animadvert",
				"animastic",
				"animism",
				"anion",
				"anisothenic",
				"anker",
				"ankus",
				"ankyroid",
				"anlace",
				"anneal",
				"annectent",
				"annihilationism",
				"annodated",
				"annomination",
				"annuent",
				"annulet",
				"annulose",
				"anocathartic",
				"anodontia",
				"anodyne",
				"anoesis",
				"anogenic",
				"anomia",
				"anomic",
				"anomie",
				"anomphalous",
				"anon",
				"anonym",
				"anopheline",
				"anopisthographic",
				"anopsia",
				"anorchous",
				"anosmia",
				"anotic",
				"ansate",
				"anserine",
				"anta",
				"antalgic",
				"antanaclasis",
				"antapology",
				"antarchy",
				"anteambulo",
				"antechapel",
				"antejentacular",
				"anteloquy",
				"antelucan",
				"antemundane",
				"antenniferous",
				"antepast",
				"antependium",
				"antephialtic",
				"antepone",
				"anteprandial",
				"antevenient",
				"anthelion",
				"anthelminthic",
				"anthesis",
				"anthomancy",
				"anthomania",
				"anthophilous",
				"anthorism",
				"anthracomancy",
				"anthrophobia",
				"anthropobiology",
				"anthropogenesis",
				"anthropoglot",
				"anthropolatry",
				"anthropolith",
				"anthropomancy",
				"anthropopathy",
				"anthropophaginian",
				"anthropophagous",
				"anthroposophy",
				"anthropotheism",
				"antibasilican",
				"antiblastic",
				"antibromic",
				"antichresis",
				"antichthon",
				"anticryptic",
				"antidisestablishmentarianism",
				"antigalactic",
				"antigropelos",
				"antilapsarianism",
				"antilegomena",
				"antilogarithm",
				"antilogism",
				"antilogy",
				"antimnemonic",
				"antimony",
				"antinomianism",
				"antinomy",
				"antipedobaptism",
				"antiperistasis",
				"antiphon",
				"antiphrasis",
				"antipudic",
				"antiscian",
				"antistrophe",
				"antithalian",
				"antithesis",
				"antitypy",
				"antonomasia",
				"antre",
				"antrorse",
				"anuptaphobia",
				"anuresis",
				"anurous",
				"anzactile",
				"aorist",
				"apaesthesia",
				"apagoge",
				"apanage",
				"apantomancy",
				"apatetic",
				"apay",
				"apercu",
				"aperient",
				"aphagia",
				"aphemia",
				"apheresis",
				"aphesis",
				"aphicide",
				"aphidicide",
				"aphnology",
				"aphologistic",
				"aphotic",
				"aphrasia",
				"aphrodisiomania",
				"aphthong",
				"apian",
				"apiarian",
				"apical",
				"apiculture",
				"apiology",
				"apistia",
				"apivorous",
				"aplanatic",
				"apocalypticism",
				"apocarteresis",
				"apocatastasis",
				"apocatastisis",
				"apocope",
				"apocrisiary",
				"apodal",
				"apodictic",
				"apodosis",
				"apodysophilia",
				"apograph",
				"apolaustic",
				"apologetics",
				"aponia",
				"apopemptic",
				"apophasis",
				"apophoret",
				"apophthegm",
				"aporia",
				"aposiopesis",
				"apositia",
				"apostasy",
				"apostil",
				"apostrophe",
				"apotelesm",
				"apothegm",
				"apotheosis",
				"apotropaic",
				"apparitor",
				"appendant",
				"apperception",
				"appersonation",
				"appetence",
				"applanate",
				"apport",
				"appose",
				"apposite",
				"approbation",
				"apprompt",
				"appropinquity",
				"appui",
				"appulse",
				"appurtenance",
				"apricate",
				"aprique",
				"apse",
				"apselophesia",
				"apsidal",
				"apterygial",
				"aptotic",
				"aptronym",
				"apyrexy",
				"aquamanile",
				"aquaphobia",
				"aquarelle",
				"aquifer",
				"aquiform",
				"aquiline",
				"araba",
				"arachibutyrophobia",
				"arachnivorous",
				"arachnology",
				"arachnophobia",
				"araneidan",
				"araneiform",
				"araneous",
				"araphorostic",
				"aration",
				"arbalest",
				"arborescent",
				"arboricolous",
				"arboriform",
				"arbrolatry",
				"arbuscle",
				"arbustum",
				"arcanna",
				"arcate",
				"archaeolatry",
				"archelogy",
				"archet",
				"archididascalian",
				"archididascalos",
				"archimandrite",
				"archimime",
				"architectonics",
				"architrave",
				"archology",
				"arciform",
				"arctician",
				"arctogaeal",
				"arctoid",
				"arctophile",
				"arctophily",
				"arcuate",
				"ard",
				"ardass",
				"arefy",
				"arenaceous",
				"arenoid",
				"areology",
				"areometer",
				"areopagitic",
				"aret",
				"aretaics",
				"arete",
				"argand",
				"argent",
				"argentiferous",
				"argentocracy",
				"argil",
				"argillaceous",
				"argol",
				"argol",
				"argosy",
				"arguria",
				"argute",
				"argyll",
				"arietine",
				"arietinous",
				"aright",
				"ariolation",
				"aristarch",
				"aristarchy",
				"aristology",
				"arithmancy",
				"arithmocracy",
				"arithmogram",
				"arithmomania",
				"armamentarium",
				"armigerous",
				"armillary",
				"armipotent",
				"armisonant",
				"armomancy",
				"armure",
				"aroint",
				"arpent",
				"arpenteur",
				"arrant",
				"arras",
				"arrasene",
				"arrect",
				"arrendator",
				"arreptitious",
				"arrestant",
				"arrhizal",
				"arris",
				"arrogate",
				"arrosive",
				"arthrology",
				"arthroscope",
				"arundiferous",
				"arundinaceous",
				"arval",
				"ascesis",
				"asceticism",
				"ascham",
				"ascian",
				"aseity",
				"ashlar",
				"ashplant",
				"asinine",
				"asitia",
				"askefise",
				"asomatous",
				"asonia",
				"asperge",
				"aspergilliform",
				"aspergillum",
				"asperity",
				"asperse",
				"aspersory",
				"aspheterism",
				"aspidate",
				"aspidomancy",
				"asportation",
				"assart",
				"assecuration",
				"assentation",
				"asseveration",
				"assibilate",
				"assiduity",
				"assizer",
				"assocative",
				"assoil",
				"assot",
				"assuefaction",
				"assuetude",
				"assurgent",
				"astacology",
				"astatic",
				"asteism",
				"asterism",
				"astern",
				"astheniology",
				"asthenopia",
				"astichous",
				"astragal",
				"astragalomancy",
				"astraphobia",
				"astrapophobia",
				"astriction",
				"astringe",
				"astrionics",
				"astrobleme",
				"astrobolism",
				"astrogeology",
				"astrognosy",
				"astrogony",
				"astrolatry",
				"astrologaster",
				"astromancy",
				"astrometeorology",
				"astrophile",
				"astroseismology",
				"astrut",
				"asynartetic",
				"asyndeton",
				"atactic",
				"ataraxia",
				"atavism",
				"ateknia",
				"atelier",
				"ateliosis",
				"athanasy",
				"athanor",
				"atheling",
				"athenaeum",
				"athermic",
				"athetesis",
				"athetosis",
				"athwart",
				"athymia",
				"atimy",
				"atlantes",
				"atlas",
				"atmatertera",
				"atmology",
				"atmometer",
				"atocia",
				"atokous",
				"atomism",
				"atony",
				"atpatruus",
				"atrabiliary",
				"atrabilious",
				"atrament",
				"atresia",
				"atrichia",
				"atrous",
				"attainder",
				"attaint",
				"attemper",
				"attenuate",
				"atticism",
				"attingent",
				"attollent",
				"attorn",
				"attrahent",
				"attrist",
				"attrite",
				"attuition",
				"aubade",
				"aubergine",
				"aubin",
				"auceps",
				"aucupate",
				"audile",
				"audiology",
				"audiometer",
				"audiophile",
				"augean",
				"augend",
				"aught",
				"aularian",
				"aulete",
				"aulic",
				"auncel",
				"aurantiaceous",
				"aureity",
				"aureole",
				"auricomous",
				"auricular",
				"auriferous",
				"aurifex",
				"auriform",
				"aurigation",
				"aurilave",
				"auriphrygia",
				"auriscope",
				"aurochs",
				"aurulent",
				"auscultation",
				"auslaut",
				"austringer",
				"austromancy",
				"autarchy",
				"autarkic",
				"autecology",
				"autocephality",
				"autocoprophagy",
				"autocracy",
				"auto-da-fe",
				"autodidact",
				"autogenesis",
				"autognosis",
				"autolatry",
				"autology",
				"automorphism",
				"automysophobia",
				"autonym",
				"autophagy",
				"autophanous",
				"autophobia",
				"autoschediasm",
				"autosoterism",
				"autotelic",
				"autothaumaturgist",
				"autotheism",
				"autotropic",
				"auxanometer",
				"auxesis",
				"auxology",
				"auxometer",
				"aval",
				"avalement",
				"avaunt",
				"avaunt",
				"aveniform",
				"averruncate",
				"averruncator",
				"avicide",
				"avicular",
				"avinosis",
				"avionics",
				"avital",
				"avizandum",
				"avolitional",
				"avulse",
				"avuncular",
				"awn",
				"axilla",
				"axiniform",
				"axinomancy",
				"axiology",
				"azimuth",
				"azoth",
				"azuline",
				"azure",
				"azymous"
			};
			#endregion
		}

		public void GetSuggestions(string text)
		{
			if (this.SuggestionsReceived != null)
			{
				this.SuggestionsReceived(this, new SuggestionsReceivedEventArgs(items.Where(s => s.StartsWith(text)).Take(20).ToList()));
			}
		}
	}
}